Attribute VB_Name = "Module1"
Option Explicit
Public Const Pi = 3.14159265358979
Public Const qq = Pi / 180 '     
Public Sub Main()
 Dim RASun As Double, DecSun As Double, RadiusSun As Double, AzSun As Double, HSun As Double
 Dim RA1() As Double, DEC1() As Double, i As Integer, N As Integer
 Dim r(3) As Double, MatrY(3, 3) As Double, MatrZ(3, 3) As Double, ry(3) As Double, rz(3) As Double
 Dim RA2() As Double, DEC2() As Double, Lat As Double, Az() As Double, H() As Double, DugaEcv As Double
 Dim DugaAz As Double, GMST_m As Double, Longitude As Double
 RASun = 90.929278 '   
 DecSun = 23.434178 '  
 RadiusSun = 0.262306 '  
 Lat = 45 ' 
 Longitude = 45 ' 
 GMST_m = (3 + 3 / 60 + 43 / 60) * 15 + Longitude '   
 '    
 Form1.txtcom.Text = "     " & Format(RadiusSun, "0.000000")
 For i = 0 To 360 Step 45
  N = N + 1
  ReDim Preserve RA1(N), DEC1(N)
  RA1(N) = i
  DEC1(N) = 90 - RadiusSun
  Call PrintCom("RA1=" & Str(RA1(N)) & "  DEC1=" & Str(DEC1(N)))
 Next i
 '          
 Call PrintCom("  ,       ")
 Call CreateMatrixY(90 - DecSun, MatrY) '      Y
 Call CreateMatrixZ(RASun, MatrZ) '      Z
 ReDim RA2(N), DEC2(N), Az(N), H(N)
 For i = 1 To N
  Call CreateVector(RA1(i), DEC1(i), 1, r) '    
  Call MultiplyArray(MatrY, r, ry)   '     Y
  Call MultiplyArray(MatrZ, ry, rz)  '     Z
  Call Angles_from_Vector(rz, RA2(i), DEC2(i)) '     
  Call PrintCom("RA2=" & Str(RA2(i)) & "  DEC2=" & Str(DEC2(i)))
  Call AzimuthCoordinate(GMST_m - RA2(i), DEC2(i), Lat, Az(i), H(i)) '    
  'Call PrintCom("Az=" & Str(Az(i)) & "  H=" & Str(H(i)))
 Next i
 '     
 Call PrintCom("         ")
 Call AzimuthCoordinate(GMST_m - RASun, DecSun, Lat, AzSun, HSun) '   -   
 For i = 1 To N
  DugaEcv = Angle_Distance(RASun, RA2(i), DecSun, DEC2(i))
  DugaAz = Angle_Distance(AzSun, Az(i), HSun, H(i))
  Call PrintCom("dEcvCoord=" & Format(DugaEcv, "0.000000") & "   dAzCoord=" & Format(DugaAz, "0.000000"))
 Next i
End Sub
' 
Private Sub PrintCom(st As String)
 Form1.txtcom.Text = Form1.txtcom.Text & Chr(13) & Chr(10) & st
End Sub
'   d()   (az,h)
Private Sub CreateVector(Az As Double, H As Double, r As Double, D() As Double)
 D(1) = r * Cos(Az * qq) * Cos(H * qq)
 D(2) = r * Sin(Az * qq) * Cos(H * qq)
 D(3) = r * Sin(H * qq)
End Sub
'    B  Y   ( )
Private Sub CreateMatrixY(A As Double, b() As Double)
 Dim T As Double
 T = A * qq
 b(1, 1) = Cos(T): b(2, 1) = 0: b(3, 1) = Sin(T)
 b(1, 2) = 0: b(2, 2) = 1: b(3, 2) = 0
 b(1, 3) = -Sin(T): b(2, 3) = 0: b(3, 3) = Cos(T)
End Sub
'    B  Z   ( )
Private Sub CreateMatrixZ(A As Double, b() As Double)
 Dim T As Double
 T = A * qq
 b(1, 1) = Cos(T): b(2, 1) = -Sin(T): b(3, 1) = 0
 b(1, 2) = Sin(T): b(2, 2) = Cos(T): b(3, 2) = 0
 b(1, 3) = 0: b(2, 3) = 0: b(3, 3) = 1
End Sub
' C=A*b    
' A[3,3], b[3]
Private Sub MultiplyArray(A() As Double, b() As Double, C() As Double)
 Dim i As Byte, j As Byte, s As Double
 For j = 1 To 3
  s = 0
   For i = 1 To 3
    s = s + A(i, j) * b(i)
   Next i
  C(j) = s
 Next j
 End Sub
'   (ra,dec)   r()
Private Sub Angles_from_Vector(r() As Double, ra As Double, Dec As Double)
 ra = Atn2(r(2), r(1)) / qq
 Dec = Atn2(r(3), Sqr(r(1) ^ 2 + r(2) ^ 2)) / qq
 If ra < 0 Then ra = ra + 360
End Sub
'   -I (th,dec)   (az,h)   Lat
Private Sub AzimuthCoordinate(th As Double, Dec As Double, Lat As Double, Az As Double, H As Double)
 Dim sinh As Double, z As Double, SinAz As Double, CosAz As Double
 sinh = Sin(Lat * qq) * Sin(Dec * qq) + Cos(Lat * qq) * Cos(Dec * qq) * Cos(th * qq)
 H = ArcSin(sinh) / qq
 SinAz = Sin(th * qq) * Cos(Dec * qq) / Cos(H * qq)
 CosAz = (Sin(H * qq) * Sin(Lat * qq) - Sin(Dec * qq)) / Cos(H * qq) / Cos(Lat * qq)
 Az = Atn2(SinAz, CosAz) / qq
 If Az < 0 Then Az = Az + 360
End Sub
'       
Private Function Angle_Distance(RA1 As Double, RA2 As Double, DEC1 As Double, DEC2 As Double) As Double
 Dim cosa As Double
 cosa = Sin(DEC1 * qq) * Sin(DEC2 * qq) + Cos(DEC1 * qq) * Cos(DEC2 * qq) * Cos((RA1 - RA2) * qq)
 Angle_Distance = ArcCos(cosa) / qq
End Function
